/* Main.c file generated by New Project wizard
 *
 * Created:   Mon Sep 29 2014
 * Processor: AT89C52
 * Compiler:  SDCC for 8051
 */

#include <mcs51reg.h>

void pwm_setup(void);
void io_init(void);

#define SINE_TABLE_SIZE   64
#define TIMER_CLK_FREQ    1000000UL


#define PWMPIN1  P2_0
#define PWMPIN2  P2_1
 
#define load_timer(X) {\
TH0     = (X & 0xFF00) >> 8;\
TL0     = (X & 0xFF); }

#define load_TL(X) {\
TH0 	= 0xFF;\
TL0     = (X & 0xFF); }
 
 
const unsigned short sine_table_0[SINE_TABLE_SIZE]= {\
 0XFFFF,  0XFFF9,  0XFFF3,  0XFFEC,  0XFFE6,  0XFFE0,  0XFFDA,  0XFFD4,\
 0XFFCE,  0XFFC8,  0XFFC2,  0XFFBD,  0XFFB7,  0XFFB2,  0XFFAD,  0XFFA8,\
 0XFFA4,  0XFF9F,  0XFF9B,  0XFF97,  0XFF93,  0XFF90,  0XFF8D,  0XFF8A,\
 0XFF87,  0XFF85,  0XFF83,  0XFF81,  0XFF80,  0XFF7F,  0XFF7E,  0XFF7E,\
 0XFF7E,  0XFF7E,  0XFF7E,  0XFF7F,  0XFF80,  0XFF81,  0XFF83,  0XFF85,\
 0XFF87,  0XFF8A,  0XFF8D,  0XFF90,  0XFF93,  0XFF97,  0XFF9B,  0XFF9F,\
 0XFFA3,  0XFFA8,  0XFFAD,  0XFFB2,  0XFFB7,  0XFFBD,  0XFFC2,  0XFFC8,\
 0XFFCE,  0XFFD4,  0XFFDA,  0XFFE0,  0XFFE6,  0XFFEC,  0XFFF3,  0XFFF9\
};

const unsigned short sine_table_1[SINE_TABLE_SIZE]= {\
 0XFF7D,  0XFF84,  0XFF8A,  0XFF91,  0XFF97,  0XFF9D,  0XFFA3,  0XFFA9,\
 0XFFAF,  0XFFB5,  0XFFBB,  0XFFC0,  0XFFC6,  0XFFCB,  0XFFD0,  0XFFD5,\
 0XFFD9,  0XFFDE,  0XFFE2,  0XFFE6,  0XFFEA,  0XFFED,  0XFFF0,  0XFFF3,\
 0XFFF6,  0XFFF8,  0XFFFA,  0XFFFC,  0XFFFD,  0XFFFE,  0XFFFF,  0XFFFF,\
 0XFFFF,  0XFFFF,  0XFFFF,  0XFFFE,  0XFFFD,  0XFFFC,  0XFFFA,  0XFFF8,\
 0XFFF6,  0XFFF3,  0XFFF0,  0XFFED,  0XFFEA,  0XFFE6,  0XFFE2,  0XFFDE,\
 0XFFDA,  0XFFD5,  0XFFD0,  0XFFCB,  0XFFC6,  0XFFC0,  0XFFBB,  0XFFB5,\
 0XFFAF,  0XFFA9,  0XFFA3,  0XFF9D,  0XFF97,  0XFF91,  0XFF8A,  0XFF84\
};
void main()
{
    io_init();
    pwm_setup();
    while(1);
}
         
void io_init(){
    PWMPIN1 = 0;
    PWMPIN2 = 0;
}         
 
         
void pwm_setup(void){
 
    load_timer(0xFF00)
 
    TMOD    = 0;
    EA      = 1;
    ET0     = 1;
    TR0     = 1;
}
 
 
 
void timer0() __interrupt 1 {
    static int sample = 0;
    static char sign_flag = 0, PWM_out_high = 0 ;

 	TF0 = 0;

    if(PWM_out_high)
    load_TL(sine_table_0[sample])  //load_timer(sine_table_0[sample]) instead for low freq
    else
	{
		if( ++sample >= SINE_TABLE_SIZE )
		{
			sample = 0;
			sign_flag = !sign_flag;
		}
    load_TL(sine_table_1[sample])  //load_timer(sine_table_1[sample]) instead for low freq        
    }
    
    
    if(sign_flag)
    {
        PWMPIN2 = 0;
    
        if(PWM_out_high)
            PWMPIN1 = 1;
        else
            PWMPIN1 = 0;
    }
    else
    {
        PWMPIN1 = 0;
        
        if(PWM_out_high)
            PWMPIN2 = 1;
        else
            PWMPIN2 = 0;
    }
 
    PWM_out_high = !PWM_out_high;   
}